var util = require('../../../utils/util.js');
var api = require('../../../config/api.js');
var app = getApp();
Page({
  data: {
    orderList: [],
    showType: 0,
    page: 1,
    limit: 10,
    totalPages: 1,
    myqr_show:false,//我的分享二维码
    myqr_url:null,
    myqr_blur:0,//背景模糊值
    hasLogin:false,
    goodsId:''
  },
  onLoad: function(options) {
    // 页面初始化 options为页面跳转所带来的参数
    let that = this
    try {
      var tab = wx.getStorageSync('tab');

      this.setData({
        showType: tab
      });
    } catch (e) {}

  },
  getOrderList() {
    let that = this;
    util.request(api.OrderList, {
      showType: that.data.showType,
      page: that.data.page,
      limit: that.data.limit
    }).then(function(res) {
      if (res.errno === 0) {
        console.log(res.data);
        that.setData({
          orderList: that.data.orderList.concat(res.data.list),
          totalPages: res.data.pages
        });
      }
    });
  },
  onReachBottom() {
    if (this.data.totalPages > this.data.page) {
      this.setData({
        page: this.data.page + 1
      });
      this.getOrderList();
    } else {
      wx.showToast({
        title: '没有更多订单了',
        icon: 'none',
        duration: 2000
      });
      return false;
    }
  },
  switchTab: function(event) {
    let showType = event.currentTarget.dataset.index;
    this.setData({
      orderList: [],
      showType: showType,
      page: 1,
      limit: 10,
      totalPages: 1
    });
    this.getOrderList();
  },
  onTabChange(e){
 
  let showType = e.detail.name;
  this.setData({
    orderList: [],
    showType: showType,
    page: 1,
    limit: 10,
    totalPages: 1
  });
  this.getOrderList();
  },
 
  viewService(e){
    let id=e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '../serviceDetail/serviceDetail?orderId=' +id
    })
  },
  qrtouchstart:function(){
    this.setData({
      myqr_blur:0,
      myqr_show:false  
    });
  },
  shareFriendOrCircle: function(e) {  
    let id=e.currentTarget.dataset.id;
    this.setData({
      goodsId:id
    }); 
    if (!app.globalData.hasLogin){
    wx.navigateTo({
      url: "/pages/auth/login/login"
    });
    return;
  }

    //分享 弹出图片
    let that=this;  
    wx.removeStorageSync(String(that.data.goods.id));
    //取出本地缓存中的分享图
    // let sUrl=wx.getStorageSync(String(that.data.goodsId)); 
    // if(sUrl!=null&&sUrl!=""){//获取过的分享图 不需要再次获取
    //   that.setData({ 
    //     myqr_url:sUrl,
    //     myqr_show:true,
    //     myqr_blur:5
    //   });
    //   return;
    // }
     wx.showLoading({
      title: '生成中',
    });
    util.request(api.QrGoodsCodeCreate, {
      goodsId:that.data.goodsId
    }).then(function(res) { 
      wx.hideLoading();
      if(res.errno==0){
      that.setData({
      myqr_url:res.data.imgUrl,
      myqr_show:true,
      myqr_blur:5
      }); 
      //保存分享图url到本地缓存
      // wx.setStorageSync(String(that.data.goodsId),res.data.imgUrl);
    } else if(res.errno==501){
      wx.navigateTo({
        url: "/pages/auth/login/login"
      });
    } else {
     wx.showToast({
       title: res.errmsg, 
       duration:5000
     }) 
    }

    }); 


    //var that = this;
    /*if (this.data.openShare === false) {
      this.setData({
        openShare: !this.data.openShare
      });
    } else {
      return false;
    }*/
  },
  // 保存分享图
  saveShare: function() {
    let that = this;
    wx.showLoading({
      title: '图片保存中',
    });
    console.log(that.data);
    wx.downloadFile({
      url: that.data.myqr_url,
      success: function(res) {
        console.log(res)
        wx.saveImageToPhotosAlbum({
          filePath: res.tempFilePath,
          success: function(res) {
            wx.hideLoading();
            wx.showModal({
              title: '存图成功',
              content: '图片成功保存到相册了，可以分享到朋友圈了',
              showCancel: false,
              confirmText: '好的',
              confirmColor: '#a78845',
              success: function(res) {
                if (res.confirm) {
                  console.log('用户点击确定');
                  that.setData({ 
                    myqr_show:false,
                    myqr_blur:0
                    }); 
                }
              }
            })
          },
          fail: function(res) {
            wx.hideLoading();
           wx.showModal({
              title: '警告',
              content: '不授权无法保存',
              showCancel: false
          })
          that.setData({ 
            myqr_show:false,
            myqr_blur:0
            }); 
        }
        })
      },
      fail: function(res) {
        wx.hideLoading();
        console.log(res);
      }
    })
  },
  // “去付款”按钮点击效果
  payOrder: function(e) {
    let that = this;
    let id = e.currentTarget.dataset.id;
    util.request(api.OrderPrepay, {
      orderId: id
    }, 'POST').then(function(res) {
      if (res.errno === 0) {
        const payParam = res.data;
        console.log("支付过程开始");
        wx.requestPayment({
          'timeStamp': payParam.timeStamp,
          'nonceStr': payParam.nonceStr,
          'package': payParam.packageValue,
          'signType': payParam.signType,
          'paySign': payParam.paySign,
          'success': function(res) {
            console.log("支付过程成功");
            util.redirect('/pages/ucenter/order/order');
          },
          'fail': function(res) {
            console.log("支付过程失败");
            util.showErrorToast('支付失败');
          },
          'complete': function(res) {
            console.log("支付过程结束")
          }
        });
      }
    });

  },
   // “删除”点击效果
   deleteOrder: function(e) {
    let that = this;
    let id = e.currentTarget.dataset.id;

    wx.showModal({
      title: '',
      content: '确定要删除此订单？',
      success: function(res) {
        if (res.confirm) {
          util.request(api.OrderDelete, {
            orderId: id
          }, 'POST').then(function(res) {
            if (res.errno === 0) {
              wx.showToast({
                title: '删除订单成功'
              });
              util.redirect('/pages/ucenter/order/order');
            } else {
              util.showErrorToast(res.errmsg);
            }
          });
        }
      }
    });
  },
 // “取消订单”点击效果
 cancelOrder: function(e) {
  let that = this;
  let id = e.currentTarget.dataset.id;

  wx.showModal({
    title: '',
    content: '确定要取消此订单？',
    success: function(res) {
      if (res.confirm) {
        util.request(api.OrderCancel, {
          orderId: id
        }, 'POST').then(function(res) {
          if (res.errno === 0) {
            wx.showToast({
              title: '取消订单成功'
            });
            util.redirect('/pages/ucenter/order/order');
          } else {
            util.showErrorToast(res.errmsg);
          }
        });
      }
    }
  });
},
 // “待上门”点击效果
 confirmOrder: function(e) {
  let that = this;
  let id = e.currentTarget.dataset.id;

  wx.showModal({
    title: '',
    content: '确认上门服务？',
    success: function(res) {
      if (res.confirm) {
        util.request(api.OrderConfirm, {
          orderId: id
        }, 'POST').then(function(res) {
          if (res.errno === 0) {
            wx.showToast({
              title: '确认上门成功！'
            });
            util.redirect('/pages/ucenter/order/order');
          } else {
            util.showErrorToast(res.errmsg);
          }
        });
      }
    }
  });
},
// “取消订单并退款”点击效果
refundOrder: function(e) {
  let that = this;
  let id = e.currentTarget.dataset.id;

  wx.showModal({
    title: '',
    content: '确定要取消此订单？',
    success: function(res) {
      if (res.confirm) {
        util.request(api.OrderRefund, {
          orderId: id
        }, 'POST').then(function(res) {
          if (res.errno === 0) {
            wx.showToast({
              title: '取消订单成功'
            });
            util.redirect('/pages/ucenter/order/order');
          } else {
            util.showErrorToast(res.errmsg);
          }
        });
      }
    }
  });
},
  onReady: function() {
    // 页面渲染完成
  },
  onShow: function() {
    // 页面显示
    this.getOrderList();
  },
  onHide: function() {
    // 页面隐藏
  },
  onUnload: function() {
    // 页面关闭
  }
})